unit LoggerForm;

interface

uses
  Windows, Forms, ComCtrls, StdCtrls, Controls, Grids, BaseGrid, AdvGrid, Buttons,
  Graphics, Classes, SysUtils, LoggerSettingsForm, Menus, ExtCtrls, Clipbrd,
  ImgList, Dialogs;

  type
    TLogData = array[1..12] of string;

  type
  TALoggerForm = class(TForm)
    Label7: TLabel;
    Label8: TLabel;
    btReadLog: TBitBtn;
    BitBtn10: TBitBtn;
    BitBtn6: TBitBtn;
    Label15: TLabel;
    SearchFButton: TBitBtn;
    FromDate: TDateTimePicker;
    ToDate: TDateTimePicker;
    BitBtn1: TBitBtn;
    SpeedButton1: TSpeedButton;
    SearchCB: TComboBox;
    PopupMenu1: TPopupMenu;
    CutPopup: TMenuItem;
    CopyPopup: TMenuItem;
    PastePopup: TMenuItem;
    SearchBButton: TBitBtn;
    N4: TMenuItem;
    SelectAllPopup: TMenuItem;
    LogPanel: TPanel;
    StringGrid1: TStringGrid;
    ImageList1: TImageList;
    ReadLogInfoPanel: TPanel;
    BitBtn2: TBitBtn;
    Pb: TProgressBar;
    Label1: TLabel;
    Label2: TLabel;
    N1: TMenuItem;
    FilterPopup: TMenuItem;
    SortDownPopup: TMenuItem;
    SortUpPopup: TMenuItem;
    OpenButton: TBitBtn;
    LogFilesCB: TComboBox;
    LbLogFile: TLabel;
    OpenDialog1: TOpenDialog;
    Label3: TLabel;
    procedure BitBtn11Click(Sender: TObject);
    procedure btReadLogClick(Sender: TObject);
//    procedure FromDateChange(Sender: TObject);
    procedure AddLine(LogData : TLogData);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SearchFButtonClick(Sender: TObject);
    procedure SearchStrKeyPress(Sender: TObject; var Key: Char);
    procedure SearchCBKeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SearchBButtonClick(Sender: TObject);
    procedure Search(Direction : integer);
    procedure LogPanelResize(Sender: TObject);
    procedure SelectAllPopupClick(Sender: TObject);
    procedure CopyToCB(Sender: TObject);
    procedure PasteFromCB(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure SortDownPopupClick(Sender: TObject);
    procedure FilterPopupClick(Sender: TObject);
    procedure OpenButtonClick(Sender: TObject);
    procedure SortUpPopupClick(Sender: TObject);
    procedure Sort(SortType : integer);
    procedure Label3Click(Sender: TObject);

  private
    { Private declarations }
  public
    LogFileName1C : PChar;
    RowBMP : TBitmap;
    hMainWND : THandle;
    { Public declarations }
  end;

var
  ALoggerForm: TALoggerForm;
  Executed : boolean;

  function ShellExecute(hWnd: HWND; Operation, FileName, Parameters, Directory: PChar; ShowCmd: Integer): HINST; stdcall;

implementation

{$R *.dfm}
  function ShellExecute; external 'shell32.dll' name 'ShellExecuteA';

  function LogStrToDate(P : PChar) : TDate;
  var
    S : string;
  begin
    S := P[6]+P[7]+'.'+P[4]+P[5]+'.'+P[0]+P[1]+P[2]+P[3];// 20050901 01.09.2005
    Result := StrToDate(S);
  end;

  // : P -     -
  //      
  //   -
  function LogStrToDateNum(P : PChar) : integer;
  var
    S : string;
  begin
    SetString(S, P, 8);
    Result := StrToInt(S);
  end;

  //  TDate   
  function DateToDateNum(D : TDate) : integer;
  var
    P : PChar;
    S2 : string;
  begin
    P := PChar(DateToStr(D));
    S2 := P[6]+P[7]+P[8]+P[9]+P[4]+P[5]+P[0]+P[1];
    Result := StrToInt(S2);
  end;

///      :-(

{procedure BitBtn11Click(Sender: TObject);
var
  TmpFileName : string;
  Str1 :string;
  ActStr1C, ObjStr1C : string;
  ActTypeStr : string;
  TmpStr2, TmpStr : string;
  RecCount1C : integer;
  ObjCount1C : integer;
  oldFM : integer;
  F,F2       : File;
  buff        : AnsiString;
  written,readed      : integer;
  blockStart: integer;
  Pos1, Pos2 : integer;
  FileAttrs,FSize, CurFSize: Integer;
  LastFTPReferenceTime : TDateTime;
  _Str : string;
  i : integer;
  ch : char;
  BegFound , EndFound : boolean;
  pCurStr : PChar;
  BuffShift : integer;
begin
  //FileAttrs := faHidden + faSysFile + faVolumeID + faArchive + faAnyFile;
  if FileExists(LogFileName1C) then
    try // except
      SetLength( buff, 16384);
      AssignFile( F, LogFileName1C);
      try // finally
        oldFM := FileMode;
        FileMode := 0;
        reset( F,1);
        Str1 := '';
        BegFound := false;
        EndFound := false;
        pCurStr := @buff;
        while not eof( F ) do begin
          BlockRead( F, buff[1], 16384, readed);
          //BuffShift := 0;
          //Pos
          //  
          //   -     
          //    
          if LogStrToDateNum(pCurStr) >= DateToDateNum(DateEdit1.Date) then begin
            BegFound := true;// !
          end;

          if not BegFound then begin

          end;


          i := 1;
          while (i < readed) do begin
            ch := Char(Buff[i]);
            Str1 := Str1 + Ch;
            if ch = #13 then begin
            ///   !!!!
            RecCount1C := RecCount1C + 1;
            ActTypeStr := ' ';
            Pos1 := Pos('DistUplStatus;', Str1);
            if Pos1 = 0 then begin
            Pos1 := Pos('DistDnldStatus;', Str1);
            if Pos1 <> 0 then ActTypeStr := ': ';
            end else begin
            ActTypeStr := ': ';
          end;
          if Pos1 > 0 then Delete(Str1,1,Pos1);
          Pos2 := Pos('RestructStatus;', Str1);
          if Pos2 > 0 then begin
          ActTypeStr := ' ... ';
          Delete(Str1,1,Pos2);
        end;
        if (Pos1 > 0) or (Pos2 > 0) then begin
        // 2-    - 
        Delete(Str1,1,Pos(';', Str1));
                  Delete(Str1,1,Pos(';', Str1));
                  TmpStr2 := AnsiLeftStr(Str1,Pos(';', Str1)-1);
                // 4- 
                  Delete(Str1,1,Pos(';', Str1));
                  Delete(Str1,1,Pos(';', Str1));
                  TmpStr := AnsiLeftStr(Str1,Pos(' ', Str1));
                  if (TmpStr <> ObjStr1C) or (TmpStr2 <> ActStr1C) then begin
                    ObjStr1C := TmpStr;
                    ActStr1C := TmpStr2;
                    ObjCount1C := 0;
                  end;
                  ObjCount1C := ObjCount1C + 1;
                end;
                    Str1 := '';
                  end;
                  i := i + 1;
                end;
              end;
            finally
              SetLength( buff, 0 );
              CloseFile( F );
              FileMode := oldFM;
            end;
      except
      end;
end;
}
{procedure TALoggerForm.BitBtn11Click(Sender: TObject);
var
  TmpFileName : string;
  Str1 :string;
  ActStr1C, ObjStr1C : string;
  ActTypeStr : string;
  TmpStr2, TmpStr : string;
  RecCount1C : integer;
  ObjCount1C : integer;
  oldFM : integer;
  F,F2       : File;
  buff        : AnsiString;
  written,readed      : integer;
  blockStart: integer;
  Pos1, Pos2 : integer;
  FileAttrs,FSize, CurFSize: Integer;
  LastFTPReferenceTime : TDateTime;
  _Str : string;
  i : integer;
  ch : char;
  BegFound , EndFound : boolean;
  pCurStr : PChar;
  BuffShift : integer;
  aStream : TFileStream;
  LogArray : TStrings;
  LogStrArray : TStrings;
  Coment : String;
begin
  //FileAttrs := faHidden + faSysFile + faVolumeID + faArchive + faAnyFile;
  if FileExists(LogFileName1C) then
    try // except
      LogStringGrid.BeginUpdate;
      try // finally
        LogStringGrid.RowCount := 1;
        SetLength( buff, 16384);
        AssignFile( F, LogFileName1C);
        LogArray := TStringList.Create;
        try // finally
          LogStrArray := TStringList.Create;
          try // finally
            oldFM := FileMode;
            FileMode := 0;
            reset( F,1);
            Str1 := '';
            BegFound := false;
            EndFound := false;
            //pCurStr := @buff;
            while not eof( F ) do begin
              BlockRead( F, buff[1], 16384, readed);
              LogArray.Text := Buff;
              for i := 0 to LogArray.Count - 1 do begin
                Str1 := Str1 + LogArray.Strings[i];
                LogStrArray.Text := StringReplace(Str1, ';',#13#10,[rfReplaceAll]);
                if LogStrArray.Count >= 9 then begin
                  LogStringGrid.RowCount := LogStringGrid.RowCount + 1;
                  LogStringGrid.Cells[1,LogStringGrid.RowCount-1] := LogStrArray.Strings[0];
                  LogStringGrid.Cells[2,LogStringGrid.RowCount-1] := LogStrArray.Strings[1];
                  LogStringGrid.Cells[3,LogStringGrid.RowCount-1] := LogStrArray.Strings[2];
                  LogStringGrid.Cells[4,LogStringGrid.RowCount-1] := LogStrArray.Strings[7];
                  Coment := Trim(StringReplace(LogStrArray.Strings[8],'<EOL>',#13#10,[rfReplaceAll]));
                  if Coment <> '' then LogStringGrid.AddComment(4,LogStringGrid.RowCount-1,Coment);
                  Str1 := '';
                end;
              end;
            end;
            CloseFile( F );
            FileMode := oldFM;
          finally
            LogStrArray.Free;
          end;
        finally
          LogArray.Free;
        end;
      finally
        LogStringGrid.EndUpdate;
      end;
    except
    end;
    SetLength( buff, 0 );
end;

}

procedure TALoggerForm.AddLine(LogData : TLogData);
var
  CurRow : integer;
begin
  CurRow := StringGrid1.RowCount-1;
//  LogStringGrid.RowCount := CurRow+1;
  ///*****
//  StringGrid1.RowCount   := CurRow+1;
  StringGrid1.RowCount := CurRow+2;
  StringGrid1.Row := CurRow;

//  StringGrid1.RowCells[1,CurRow] := LogData[1];

  StringGrid1.Cells[0,CurRow] := LogData[6];
  StringGrid1.Cells[1,CurRow] := LogData[1];
  StringGrid1.Cells[2,CurRow] := LogData[2];
  StringGrid1.Cells[3,CurRow] := LogData[3];
  StringGrid1.Cells[4,CurRow] := LogData[8];

  ///*****

{  LogStringGrid.Cells[1,CurRow] := LogData[1];
  LogStringGrid.Cells[2,CurRow] := LogData[2];
  LogStringGrid.Cells[3,CurRow] := LogData[3];
  LogStringGrid.Cells[4,CurRow] := LogData[8];
  }
end;

procedure TALoggerForm.btReadLogClick(Sender: TObject);
var
  LogData: TLogData;
  F : File;
  buff: AnsiString;
  LogArray : TStrings;
  LogStrArray : TStrings; 
  oldFM : integer;
  StrL, LinesCounter: Integer;
  Str1: String; 
  readed: integer; 
  i: Integer; 
  i2: Integer; 
  oldCfg1, oldCfg2: Boolean; 
  Data1,Data2: String;
  BlockSize, OneProcent: Integer;
  CurLogFile : string;
begin
  if Executed then exit;

  if (GetWindowLong(hMainWND,GWL_EXSTYLE) and WS_EX_TOPMOST) = 0 then
    FormStyle := fsNormal
  else
    FormStyle := fsStayOnTop;
  Show;

  Executed := true;
  try //finally
    LinesCounter := 0;
    StringGrid1.RowCount := 2;
    StringGrid1.FixedRows := 1;
    StringGrid1.Cells[1,0] := '';
    StringGrid1.Cells[2,0] := '';
    StringGrid1.Cells[3,0] := '';
    StringGrid1.Cells[4,0] := '';
    BlockSize:=65536;
    LongDateFormat  :='yyyymmdd';
    Shortdateformat :='yyyymmdd';

    Data1:=DateToStr(FromDate.Date);
    Data2:=DateToStr(ToDate.Date);
    if LogFilesCB.Text = '' then begin
      LogFilesCB.Items.Insert(0,LogFileName1C);
      LogFilesCB.ItemIndex := 0;
    end;
    CurLogFile := LogFilesCB.Text;
    if not FileExists(CurLogFile) then begin
      Application.MessageBox('   !','',0);
      Exit;
    end;
  Pb.Position:=0;
  LogPanel.Visible := false;
  ReadLogInfoPanel.Visible := true;
  Label1.Caption := '  '+CurLogFile;
  SetLength( buff, BlockSize);
  LogArray := TStringList.Create;
  LogStrArray := TStringList.Create;
  SetLength( buff, BlockSize);
  try //finally
    oldFM := FileMode;
    AssignFile(F, CurLogFile);
    FileMode := 0;  {     }
    Reset(F,1);
    Pb.Min:=0;
    Pb.Max:=FileSize(F);
    OneProcent := Pb.Max div 100;
    while not eof( F ) do begin
      Application.ProcessMessages;
      if not Executed then Break;
      readed := BlockSize;
      BlockRead(F, buff[1],BlockSize, readed);
      if readed < BlockSize then SetLength( buff, readed);

      LogArray.Text := Buff;
      SetLength( Str1, 0);
      for i:= 0 to LogArray.Count - 1 do begin

        LogStrArray.Text := StringReplace(LogArray.Strings[i], ';',#13#10,[rfReplaceAll]);
        if LogStrArray.Count >= 9 then begin
          //if  (LogStrArray.Strings[0]>=Data1) and (LogStrArray.Strings[0]<=Data2) Then
          begin
{            If chbErrorOnly.Checked Then Begin
              If POS('TaskErr',LogStrArray.Strings[5])=0 Then Next;
            End;
}
            LogData[1]:=LogStrArray.Strings[0];
            LogData[2]:=LogStrArray.Strings[1];
            LogData[3]:=LogStrArray.Strings[2];
            LogData[4]:=LogStrArray.Strings[3];
            LogData[5]:=LogStrArray.Strings[4];
            LogData[6]:=LogStrArray.Strings[5];
            LogData[7]:=LogStrArray.Strings[6];
            LogData[8]:=LogStrArray.Strings[7];
            LogData[9]:=LogStrArray.Strings[8];
            AddLine(LogData);
            Inc(LinesCounter);
          end;
        end;
      end;
      if Readed=BlockSize then begin
        Str1 := LogArray.Strings[LogArray.count-1];
        i:=FilePos(F)-Length(Str1);
        Seek(F,i);
      end;
      i:=FilePos(F);
      Pb.Position:=i;
      Label2.Caption := IntToStr(i div OneProcent) + ' %';
      SetLength( Str1, 0);
    end;

    CloseFile( F );
    FileMode := oldFM;
  finally
    ReadLogInfoPanel.Visible := false;
    LogPanel.Visible := true;
    SetLength( buff, 0);
    LogArray.Free;
    LogArray := Nil;
    LogStrArray.Free;
    LogStrArray :=Nil;
  end;
  finally
    Executed := false;
  end;
end;


procedure TALoggerForm.BitBtn11Click(Sender: TObject);
{var
  TmpFileName : string;
  Str1 :string;
  ActStr1C, ObjStr1C : string;
  ActTypeStr : string;
  TmpStr2, TmpStr : string;
  RecCount1C : integer;
  ObjCount1C : integer;
  oldFM : integer;
  F,F2       : File;
  buff        : AnsiString;
  written,readed      : integer;
  blockStart: integer;
  Pos1, Pos2 : integer;
  FileAttrs,FSize, CurFSize: Integer;
  LastFTPReferenceTime : TDateTime;
  _Str : string;
  i : integer;
  ch : char;
  BegFound , EndFound : boolean;
  pCurStr : PChar;
  BuffShift : integer;
  aStream : TFileStream;
  LogArray : TStrings;
  LogStrArray : TStrings;
  Coment : String;
  FileStream : TFileStream;
  iFileHandle : integer;
}begin
{  //FileAttrs := faHidden + faSysFile + faVolumeID + faArchive + faAnyFile;
  if FileExists(LogFileName1C) then
    try // except
//      StringGrid1.BeginUpdate;
      try // finally
        StringGrid1.RowCount := 1;
        //SetLength( buff, 16384);
        //AssignFile( F, LogFileName1C);
        LogArray := TStringList.Create;
        //FileStream : TFileStream;
        try // finally
          LogStrArray := TStringList.Create;
          try // finally
            oldFM := FileMode;
            FileMode := 0;

            FileStream := TFileStream.Create(LogFileName1C,fmOpenRead);
            LogArray.LoadFromStream(FileStream);
            //reset( F,1);
            Str1 := '';
            BegFound := false;
            EndFound := false;
            //pCurStr := @buff;
             for i := 0 to LogArray.Count - 1 do begin
                Str1 := Str1 + LogArray.Strings[i];
                LogStrArray.Text := StringReplace(Str1, ';',#13#10,[rfReplaceAll]);
                if LogStrArray.Count >= 9 then begin
                  LogStringGrid.RowCount := LogStringGrid.RowCount + 1;
                  LogStringGrid.Cells[1,LogStringGrid.RowCount-1] := LogStrArray.Strings[0];
                  LogStringGrid.Cells[2,LogStringGrid.RowCount-1] := LogStrArray.Strings[1];
                  LogStringGrid.Cells[3,LogStringGrid.RowCount-1] := LogStrArray.Strings[2];
                  LogStringGrid.Cells[4,LogStringGrid.RowCount-1] := LogStrArray.Strings[7];
                  Coment := Trim(StringReplace(LogStrArray.Strings[8],'<EOL>',#13#10,[rfReplaceAll]));
                  if Coment <> '' then LogStringGrid.AddComment(4,LogStringGrid.RowCount-1,Coment);
                  Str1 := '';
                end;
              end;
            //end;
            //CloseFile( F );
            FileMode := oldFM;
          finally
            LogStrArray.Free;
          end;
        finally
          LogArray.Free;
        end;
      finally
        LogStringGrid.EndUpdate;
      end;
    except
    end;
    SetLength( buff, 0 );
end;
}
//end
{procedure TALoggerForm.DateEdit1Change(Sender: TObject);
begin
}
end;

procedure TALoggerForm.BitBtn1Click(Sender: TObject);
begin
  ASettingsForm.FormStyle := FormStyle;
  with ASettingsForm do begin
    MlgFileName.Text := fLogFileName;
    MaxLogSize.Text := IntToStr(fMaxLogSize);
    LogActive.Checked   := fActive;
    Show;
  end;
end;

procedure TALoggerForm.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TALoggerForm.Search(Direction : integer);
 var FirstCol, CurCol, CurRow : integer;
 CurCellStr : string;
 _SearchStr : string;
begin
  //_SearchStr := StrUpper(PChar(SearchCB.Text));
  _SearchStr := SearchCB.Text;
  if (_SearchStr <> '') then begin
    if SearchCB.Items.IndexOf(_SearchStr) < 0 then SearchCB.Items.Insert(0,SearchCB.Text);
    FirstCol := StringGrid1.Col+Direction;
    CurRow := StringGrid1.Row;
    while (CurRow>0) and (CurRow<StringGrid1.RowCount)
    do begin
      CurCol := FirstCol;
      while (CurCol>0) and (CurCol<StringGrid1.ColCount) do begin
        CurCellStr := StringGrid1.Cells[CurCol,CurRow];
        if pos(_SearchStr,CurCellStr)>0 then begin
            StringGrid1.Row := CurRow;
            StringGrid1.Col := CurCol;
            exit;
        end;
        CurCol := CurCol + Direction;
      end;
      if Direction = 1 then FirstCol := 1
      else FirstCol := StringGrid1.ColCount-1;
      CurRow := CurRow + Direction;
    end;
  end;
end;

procedure TALoggerForm.SearchBButtonClick(Sender: TObject);
begin
  Search(-1);
end;

procedure TALoggerForm.SearchFButtonClick(Sender: TObject);
begin
  Search(1);
end;

procedure TALoggerForm.SearchStrKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    SearchFButtonClick(Sender);
end;

procedure TALoggerForm.SearchCBKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    SearchFButtonClick(Sender);
end;


procedure TALoggerForm.StringGrid1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  cKey : Char;
begin
  //cKey := CHR(Key);
  // 45 - Insert
  // 67 - 
  // 86 - V
  if ((Shift = [ssShift]) and (Key=45)) then begin
    PasteFromCB(Sender);
  end;
  if (Shift = [ssCtrl]) then begin
    if ({(Key=67) or} (Key=45{Ctrl+Insert})) then begin
      CopyToCB(Sender);
    end;
  end;
end;


procedure TALoggerForm.LogPanelResize(Sender: TObject);
var
  PW : integer;
begin
  PW := StringGrid1.Width;
  With StringGrid1 do begin
    ColWidths[1] := PW div 10;
    ColWidths[2] := PW div 10;
    ColWidths[3] := PW div 10;
    ColWidths[4] := PW - 25 - ColWidths[0]-ColWidths[1]-ColWidths[2]-ColWidths[3];
  end;
end;

procedure TALoggerForm.SelectAllPopupClick(Sender: TObject);
begin
  StringGrid1.Selection := TGridRect(Rect(1,0,StringGrid1.ColCount,StringGrid1.RowCount));
end;

procedure TALoggerForm.CopyToCB(Sender: TObject);
var
  CBStr : string; // String to copy to clipboard
  CurStr : string;
  CurCol, CurRow : integer;
  hbuf : THandle;
  bufptr : Pointer;
begin
  CBStr := '';
  for CurRow := StringGrid1.Selection.Top to StringGrid1.Selection.Bottom do begin
    for CurCol := StringGrid1.Selection.Left to StringGrid1.Selection.Right do begin
      CurStr := StringReplace(StringGrid1.Cells[CurCol,CurRow],'#9','<TAB>',[rfReplaceAll]);
      CurStr := StringReplace(CurStr,'#13#10','<EOL>',[rfReplaceAll]);
      CBStr := CBStr + StringGrid1.Cells[CurCol,CurRow]+#9;
    end;
    CBStr := CBStr + #13#10;
  end;
  Clipboard.asText:=CBStr;
end;

procedure TALoggerForm.PasteFromCB(Sender: TObject);
var
  CBStr : string; // String to copy to clipboard
begin
  CBStr := Clipboard.asText;
end;

procedure TALoggerForm.StringGrid1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
 R : TRect;
 ImgNum, P : integer;
 StStr : string;
begin
  if {(ACol > 0) and }(ARow = 0) then begin
    StringGrid1.Canvas.Pen.Color := 0;
    StringGrid1.Canvas.MoveTo(Rect.Left,Rect.Bottom);
    StringGrid1.Canvas.LineTo(Rect.Right+1,Rect.Bottom);
  end;

  if (ACol = 0) and (ARow > 0) then begin
    //StringGrid1.Canvas.Brush.Color := clGray;
    //StringGrid1.Canvas.Pen.Color := clGray;
    R := Rect;
    R.Bottom := R.Bottom + 1;
    StringGrid1.Canvas.FillRect(Rect);
    ImgNum := 7;
    StStr := StringGrid1.Cells[ACol,ARow];
    if (Pos('Err',StStr) > 0) then ImgNum := 6;

    if (Pos('OpenSession',StStr) > 0) then ImgNum := 0;
    if (Pos('CloseSession',StStr) > 0) then ImgNum := 1;
    if (Pos('JobBeg',StStr) > 0) then ImgNum := 2;
    if (Pos('JobEnd',StStr) > 0) then ImgNum := 3;

    if (Pos('TaskBeg',StStr) > 0) then ImgNum := 4;
    if (Pos('TaskEnd',StStr) > 0) then ImgNum := 5;
    if (Pos('TaskErr',StStr) > 0) then ImgNum := 6;
    if (Pos('NotifStatus',StStr) > 0) then ImgNum := 8;
    if ImgNum > -1 then begin
     ImageList1.Draw(StringGrid1.Canvas,Rect.Left+2,Rect.Top+2,ImgNum);
    end;
  end;

end;

procedure TALoggerForm.FormCreate(Sender: TObject);
begin
 RowBMP := TBitmap.Create;
end;

procedure TALoggerForm.BitBtn2Click(Sender: TObject);
begin
  Executed := false;
end;


procedure TALoggerForm.FilterPopupClick(Sender: TObject);
var
  OneProcent, i, CurCol, ChkRow, CurRow, RCount : integer;
  FilterStr, tmpstr : string;
begin
  if Executed then exit;
  Executed := true;
  Pb.Position:=0;
  RCount := StringGrid1.RowCount;
  Pb.Max := RCount;
  Pb.Min := 0;
  OneProcent := RCount div 100;
  LogPanel.Visible := false;
  ReadLogInfoPanel.Visible := true;
  with StringGrid1 do
  try
    CurCol := Col;
    CurRow := Row;
    FilterStr := Cells[CurCol,CurRow];
    CurRow := 0;
    ChkRow := 0;
    label1.Caption := '   <'+FilterStr+'>';
//-->>
    while ChkRow < RCount do begin
      if not Executed then exit;

      inc(ChkRow);
      inc(CurRow);
      if Cells[CurCol,ChkRow] <> FilterStr then begin
        //inc(CurRow);
        while ChkRow < RCount do begin
          inc(ChkRow);
          if Cells[CurCol,ChkRow] = FilterStr then break;
        end;
      end;
      if ChkRow <> CurRow then begin
        Cells[0,CurRow] := Cells[0,ChkRow];
        Cells[1,CurRow] := Cells[1,ChkRow];
        Cells[2,CurRow] := Cells[2,ChkRow];
        Cells[3,CurRow] := Cells[3,ChkRow];
        Cells[4,CurRow] := Cells[4,ChkRow];
        Rows[ChkRow].Clear;
      end;
      Pb.Position := ChkRow;
      Label2.Caption := IntToStr(ChkRow div OneProcent) + ' %';

    end;
    RowCount := CurRow;
//-->>
  finally
    LogPanel.Visible := true;
    ReadLogInfoPanel.Visible := false;
    Executed := false;
  end;
end;

procedure TALoggerForm.OpenButtonClick(Sender: TObject);
var
  ind : integer;
begin
  //if OpenDialog1.Execute then begin

  if OpenDialog1.Execute then begin
    ind := LogFilesCB.Items.IndexOf(OpenDialog1.FileName);
    if ind = -1 then
      LogFilesCB.Items.Insert(0,OpenDialog1.FileName)
    else
      LogFilesCB.Items.Exchange(0,ind);
    LogFilesCB.ItemIndex := 0;
    btReadLogClick(Sender);
  end;
end;

procedure TALoggerForm.Sort(SortType : integer);
var
  CurCol, ChkRow, CurRow, RCount : integer;
  OneProcent : integer;
  tmp, MinMaxCellStr : string;
  ToChangeRow : integer;
  ChkCellStr : PChar;
  ///
begin
  if Executed then exit;
  RCount := StringGrid1.RowCount;
  Pb.Max := RCount;
  Pb.Min := 0;
  Pb.Position:=0;
  OneProcent := RCount div 100;
  LogPanel.Visible := false;
  ReadLogInfoPanel.Visible := true;
  Executed := true;

  with StringGrid1 do
  try
    CurCol := Col;// 
    label1.Caption := '   <'+Cells[CurCol,0]+'>';
//-->>
    for CurRow := 1 to RCount - 1 do begin
      //      
      if not Executed then exit;

      MinMaxCellStr := Cells[CurCol,CurRow];
      ToChangeRow := CurRow;
      for ChkRow := CurRow + 1 to RCount - 1 do begin
        //       
        //     /
        // 
        ChkCellStr := PChar(Cells[CurCol,ChkRow]);
        if (SortType < 0) and (MinMaxCellStr < ChkCellStr)
        or (SortType > 0) and (MinMaxCellStr > ChkCellStr)
        then begin
          MinMaxCellStr := ChkCellStr;// 
          //  
          ToChangeRow := ChkRow;//     
        end;
      end;
      if ToChangeRow > CurRow then begin
        //  CurRow       
        //  ->

        tmp := Cells[0,CurRow];Cells[0,CurRow] := Cells[0,ToChangeRow];Cells[0,ToChangeRow] := tmp;
        tmp := Cells[1,CurRow];Cells[1,CurRow] := Cells[1,ToChangeRow];Cells[1,ToChangeRow] := tmp;
        tmp := Cells[2,CurRow];Cells[2,CurRow] := Cells[2,ToChangeRow];Cells[2,ToChangeRow] := tmp;
        tmp := Cells[3,CurRow];Cells[3,CurRow] := Cells[3,ToChangeRow];Cells[3,ToChangeRow] := tmp;
        tmp := Cells[4,CurRow];Cells[4,CurRow] := Cells[4,ToChangeRow];Cells[4,ToChangeRow] := tmp;

      end;
      Pb.Position := CurRow;
      Label2.Caption := IntToStr(CurRow div OneProcent) + ' %';
      //Pb.Update;
      Application.ProcessMessages;
      //   
    end;
//-->>
  finally
    LogPanel.Visible := true;
    ReadLogInfoPanel.Visible := false;
    Executed := false;
  end;
end;

procedure TALoggerForm.SortDownPopupClick(Sender: TObject);
begin
 Sort(-1);
end;

procedure TALoggerForm.SortUpPopupClick(Sender: TObject);
begin
 Sort(1);
end;

procedure TALoggerForm.Label3Click(Sender: TObject);
begin
  shellexecute(Handle,'open',PChar(TEdit(Sender).Hint),nil,nil,SW_SHOWNORMAL);
end;

end.


//http://forum.winsov.ru/index.php?showtopic=2618
